/* 
 * File:   fuses.h
 * Author: Mayur
 * Compiler bug. In the datasheet there are CONFIG1L CONFIG 1H, CONFIG 2L ,CONFIG 2H etc.
 *There are all those configuration registers in the corresponding hex file of the micro as well.
* But if we define as the different configuration registers in the hex file, it does not work so consider CONFIG1H & CONFIG1L as one CONFIG1 register.
 *  * Created on 17 October 2013, 08:05
 */

#ifndef FUSES_H
#define	FUSES_H

__CONFIG(1, XINST_OFF & SOSCSEL_DIG & INTOSCSEL_LOW & RETEN_OFF & IESO_OFF & FCMEN_OFF & PLLCFG_OFF & FOSC_INTIO1); // Regulator Power while in sleep mode is controlled by SRENREG, Digital I/O and no SOSC, Extended Set Disabled
//__CONFIG(1H, IESO_OFF & FCMEN_OFF & PLLCFG_OFF & FOSC_INTIO1);//FOSC_HS2);//Internal External Oscillator Switch Over Mode Disabled,Fail-Safe Clock Monitor Disabled,  PLL OFF, Internal Oscillator and Output of RA6 HS oscillator (High power, 16 MHz - 25 MHz)
__CONFIG(2, PWRTEN_OFF & BOREN_OFF & WDTEN_OFF);//power up timer disabled, Brown Out disabled
//__CONFIG(2H, WDTEN_ON & WDTPS_1024); //WDT disabled.
__CONFIG(3, RTCOSC_INTOSCREF & CCP2MX_PORTC & MSSPMSK_MSK7 & MCLRE_OFF ); //RTCC uses INTRC
//__CONFIG(3H, CCP2MX_PORTC & MSSPMSK_MSK7 & MCLRE_ON);//CCP2 Mux RC1,  MSSP address masking 7 Bit address masking mode, MCLR Enabled  RG5 Disabled
__CONFIG(4, STVREN_OFF & BBSIZ_BB1K ); //Stack Overflow Reset Disabled, 1K word Boot Block size,
__CONFIG(5, CP0_OFF & CP1_OFF & CP2_OFF & CP3_OFF & CPB_OFF & CPD_OFF);// Not Code Protect all
//__CONFIG(5H, CPB_OFF & CPD_OFF);// Code Protect Boot Disabled, EEPROM NOT READ PROTECT
__CONFIG(6, WRT0_OFF & WRT1_OFF & WRT2_OFF & WRT3_OFF & WRTC_OFF & WRTB_OFF & WRTD_OFF);// No Table Protection
//__CONFIG(6H, WRTC_OFF & WRTB_OFF & WRTD_OFF);// CONFIG not Write Protected, Table Boot not Write Protected, Data EE NOT WRITE PROTECTED
__CONFIG(7, EBRT0_OFF & EBRT1_OFF & EBRT2_OFF & EBRT3_OFF & EBRTB_OFF);//Table not read protected
//__CONFIG(7H, EBRTB_OFF);//Table Boot not read protected.


#endif	/* FUSES_H */

