/* 
 * File:   main.c
 * Author: Mayur
 *
 * Created on 25 September 2013, 11:54
 */


#include "htc.h"
#include "pic18f65k22.h"
#include "fuses.h"
#include <stdio.h>
#include <stdlib.h>
#include "defs.h"
#include "Interrupts.h"
#include "peripherals.h"
#include "timers.h"
#include "Port_Pins.h"

#include "mains.h"

//#include "Test.h"
bit BOR_RESET; //brown out reset occurred nBOR
bit WD_RESET; //watchdog reset occurred nTO
bit POR_RESET; //power on reset
bit CM_RESET; //configuration mismatch reset nCP
bit POR_RESET; //power on reset
bit ONCE_ONLY;
//bit y;
void reset_check (void);


bit LED_CHECK;
UBYTE   LED_COUNTER;
UBYTE   READ_DATA;
UBYTE   MSEC_500;
UBYTE   SPEED;
UBYTE   SLEEP_TIMER;

void main (void)    //
{

  //  UBYTE   i;

   // reset_check();
    peripherals_init(); //this includes oscillator settings, Watch Dog settings and other settings.
    interrupts_settings();
    Port_Pins_Initialization();// We do this to make our life easy when we want to move the codes around.
       
     interrupts_enable ();   //after all the settings turn on the interrupts now.
   
    ONCE_ONLY = FALSE;
    MSEC_500 = 50;
    SPEED = 2;
    SLEEP_TIMER = 10;
  
    while (1)   //this is our endless loop
    {
      

            if (flag_40msec == TRUE)
            {
                /***
                  when the cpu is running, the timer interrupt will count 40msec
                  * depending on the flag_40msec flag, this loop will continue working endlessly
                  */
                 SPEED--;

                if (SPEED == 0)
                {

                    SPEED = 2;

                    if (SLEEP_TIMER > 0)
                    {
                        SLEEP_TIMER--;
                        if (SLEEP_TIMER == 0)
                        {
                         external_interrupt_enable(); //after 4 second of cpu running, we enable the external interrupts & RTCC alarm interrupt
                          SLEEP();//the CPU will go into the sleep mode at 80msec*50 = 4 second
                           external_interrupt_disable();//after waking up, disable the external interrupt and disable RTCC interrupt
                            SLEEP_TIMER = 50;
                        }
                        else
                        {
                       /****
                        * 
                        when the cpu is running. SLEEP TEST pin will clock at 80msec ON,OFF.
                            **/
                    if (SLEEP_TEST == 1)
                           {
                            SLEEP_TEST = 0;
                             }
                         else
                             {

                            SLEEP_TEST = 1;
                             }
                    //*******/
                         
                        }
                    }
                    else
                    {
                        SLEEP();
                    }
                       
                }
            
                flag_40msec = FALSE;
           
             }
        
   

        
    }


}

void reset_check (void)
{
    SBOREN = 1; //brown out reset is enabled
    /*Power On Reset Check*/
    if (nPOR == 0)  //power on reset
    {
        POR_RESET = 1;
        nPOR = 1;   //re-set the flags
        nBOR = 1;   //brown out flag also goes low during the power on reset, so we make sure it reset
    }
    else
    {
        POR_RESET = 0;
    }
        /*Brown Out Reset Check*/
    if (nBOR == 0)
    {
        BOR_RESET = 1; //brown out reset occurred
        nBOR = 1;
    }
    else
    {
        POR_RESET = 0;
    }

    /*Configuration Mismatch Reset Check*/

    if (nCM == 0)
    {
        CM_RESET = 1;
        nCM = 0;
    }
    else
    {
        CM_RESET = 0;
    }

        /*Watch Dog Reset Check*/
    if (nTO == 0)
    {
        WD_RESET = 1;
        nTO = 1;
    }
    else
    {
        WD_RESET = 0;
    }
}

